#!/usr/bin/env node
"use strict";

var _get = require("lodash/get");

var _get2 = _interopRequireDefault(_get);

var _commander = require("commander");

var _commander2 = _interopRequireDefault(_commander);

var _ = require("..");

var _2 = _interopRequireDefault(_);

var _helpers = require("../helpers");

var _package = require("../../package.json");

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_commander2.default.version(_package2.default.version).description(_package2.default.description).usage('[options] <source directory>').option('-w, --watch', 'Watch files for changes').option('--root <directory>', 'Root directory for babel. This is where presets are resolved from').option('--ignored <list>', 'Ignored files and directories that match the given globs', value => value.split(',').map(item => item.trim()).filter(Boolean)).option('--write-flow-sources', 'Write .flow files that are symlinked to source files. Helps with monorepos in some cases').option('--disable-cache', 'Force recompile all files ignoring cache').option('--keep-extra-files', 'Do NOT delete extra files in the output directory').option('-o, --output-directory <directory>', 'Output directory to write transpiled files to').option('-x, --execute <entryFile>', 'Relative path of file to execute (only supported in watcher mode)').option('--execute-delay <delay>', 'Delay in ms to in between restarts of executed file (defaults to 1000ms)', value => parseInt(value, 10) || 1000).parse(process.argv);

if (_commander2.default.args.length !== 1) {
  _commander2.default.outputHelp();

  process.exit(1);
}

if (typeof _commander2.default.outputDirectory === 'undefined') {
  console.log('ERROR: You must specify output directory');

  _commander2.default.outputHelp();

  process.exit(1);
}

const config = {
  root: (0, _get2.default)(_commander2.default, 'root', process.cwd()),
  watch: (0, _get2.default)(_commander2.default, 'watch', false),
  ignored: (0, _get2.default)(_commander2.default, 'ignored', []),
  disableCache: (0, _get2.default)(_commander2.default, 'disableCache', false),
  writeFlowSources: (0, _get2.default)(_commander2.default, 'writeFlowSources', false),
  keepExtraFiles: (0, _get2.default)(_commander2.default, 'keepExtraFiles', false),
  sourceDirectory: _commander2.default.args[0],
  outputDirectory: _commander2.default.outputDirectory,
  execute: (0, _get2.default)(_commander2.default, 'execute', ''),
  executeDelay: (0, _get2.default)(_commander2.default, 'executeDelay', 250)
};

if (!config.watch && config.execute) {
  console.error('ERROR: --execute is not supported without --watch');
  process.exit(1);
}

(0, _2.default)(config).then(() => {
  if (!config.watch) {
    process.exit();
  }
}).catch(error => {
  (0, _helpers.logError)(error);
  process.exit(1);
});